'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var JSONArrow = function JSONArrow(_ref) {
  var styling = _ref.styling,
      arrowStyle = _ref.arrowStyle,
      expanded = _ref.expanded,
      nodeType = _ref.nodeType,
      onClick = _ref.onClick;
  return _react2.default.createElement(
    'div',
    _extends({}, styling('arrowContainer', arrowStyle), {
      onClick: onClick
    }),
    _react2.default.createElement(
      'div',
      styling(['arrow', 'arrowSign'], nodeType, expanded, arrowStyle),
      '\u25B6',
      arrowStyle === 'double' && _react2.default.createElement(
        'div',
        styling(['arrowSign', 'arrowSignInner']),
        '\u25B6'
      )
    )
  );
};

JSONArrow.propTypes = {
  styling: _propTypes2.default.func.isRequired,
  arrowStyle: _propTypes2.default.oneOf(['single', 'double']),
  expanded: _propTypes2.default.bool.isRequired,
  nodeType: _propTypes2.default.string.isRequired,
  onClick: _propTypes2.default.func.isRequired
};

JSONArrow.defaultProps = {
  arrowStyle: 'single'
};

exports.default = JSONArrow;