'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _JSONArrow = require('./JSONArrow');

var _JSONArrow2 = _interopRequireDefault(_JSONArrow);

var _getCollectionEntries = require('./getCollectionEntries');

var _getCollectionEntries2 = _interopRequireDefault(_getCollectionEntries);

var _JSONNode = require('./JSONNode');

var _JSONNode2 = _interopRequireDefault(_JSONNode);

var _ItemRange = require('./ItemRange');

var _ItemRange2 = _interopRequireDefault(_ItemRange);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

/**
 * Renders nested values (eg. objects, arrays, lists, etc.)
 */

function renderChildNodes(props, from, to) {
  var nodeType = props.nodeType,
      data = props.data,
      collectionLimit = props.collectionLimit,
      circularCache = props.circularCache,
      keyPath = props.keyPath,
      postprocessValue = props.postprocessValue,
      sortObjectKeys = props.sortObjectKeys;

  var childNodes = [];

  (0, _getCollectionEntries2.default)(nodeType, data, sortObjectKeys, collectionLimit, from, to).forEach(function (entry) {
    if (entry.to) {
      childNodes.push(_react2.default.createElement(_ItemRange2.default, _extends({}, props, {
        key: 'ItemRange--' + entry.from + '-' + entry.to,
        from: entry.from,
        to: entry.to,
        renderChildNodes: renderChildNodes
      })));
    } else {
      var key = entry.key,
          value = entry.value;

      var isCircular = circularCache.indexOf(value) !== -1;

      var node = _react2.default.createElement(_JSONNode2.default, _extends({}, props, { postprocessValue: postprocessValue, collectionLimit: collectionLimit }, {
        key: 'Node--' + key,
        keyPath: [key].concat(_toConsumableArray(keyPath)),
        value: postprocessValue(value),
        circularCache: [].concat(_toConsumableArray(circularCache), [value]),
        isCircular: isCircular,
        hideRoot: false
      }));

      if (node !== false) {
        childNodes.push(node);
      }
    }
  });

  return childNodes;
}

function getStateFromProps(props) {
  // calculate individual node expansion if necessary
  var expanded = props.shouldExpandNode && !props.isCircular ? props.shouldExpandNode(props.keyPath, props.data, props.level) : false;
  return {
    expanded: expanded,
    lastExpanded: expanded
  };
}

var JSONNestedNode = function (_React$Component) {
  _inherits(JSONNestedNode, _React$Component);

  _createClass(JSONNestedNode, null, [{
    key: 'getDerivedStateFromProps',


    // If props change such that this item's expandability changes,
    // change it. This allows clicking to expand/unexpand while still
    // responding to props, while not needlessly changing.
    value: function getDerivedStateFromProps(props, state) {
      var derivedState = getStateFromProps(props);
      if (derivedState.expanded !== state.lastExpanded) {
        return derivedState;
      }
      return null;
    }
  }]);

  function JSONNestedNode(props) {
    _classCallCheck(this, JSONNestedNode);

    var _this = _possibleConstructorReturn(this, (JSONNestedNode.__proto__ || Object.getPrototypeOf(JSONNestedNode)).call(this, props));

    _this.handleClick = function () {
      return _this.setState({ expanded: !_this.state.expanded });
    };

    _this.state = getStateFromProps(props);
    return _this;
  }

  _createClass(JSONNestedNode, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      var _this2 = this;

      return !!Object.keys(nextProps).find(function (key) {
        return key !== 'circularCache' && (key === 'keyPath' ? nextProps[key].join('/') !== _this2.props[key].join('/') : nextProps[key] !== _this2.props[key]);
      }) || nextState.expanded !== this.state.expanded;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          getItemString = _props.getItemString,
          nodeTypeIndicator = _props.nodeTypeIndicator,
          nodeType = _props.nodeType,
          data = _props.data,
          hideRoot = _props.hideRoot,
          createItemString = _props.createItemString,
          styling = _props.styling,
          collectionLimit = _props.collectionLimit,
          keyPath = _props.keyPath,
          labelRenderer = _props.labelRenderer,
          expandable = _props.expandable;
      var expanded = this.state.expanded;

      var renderedChildren = expanded || hideRoot && this.props.level === 0 ? renderChildNodes(_extends({}, this.props, { level: this.props.level + 1 })) : null;

      var itemType = _react2.default.createElement(
        'span',
        styling('nestedNodeItemType', expanded),
        nodeTypeIndicator
      );
      var renderedItemString = getItemString(nodeType, data, itemType, createItemString(data, collectionLimit));
      var stylingArgs = [keyPath, nodeType, expanded, expandable];

      return hideRoot ? _react2.default.createElement(
        'li',
        styling.apply(undefined, ['rootNode'].concat(stylingArgs)),
        _react2.default.createElement(
          'ul',
          styling.apply(undefined, ['rootNodeChildren'].concat(stylingArgs)),
          renderedChildren
        )
      ) : _react2.default.createElement(
        'li',
        styling.apply(undefined, ['nestedNode'].concat(stylingArgs)),
        expandable && _react2.default.createElement(_JSONArrow2.default, {
          styling: styling,
          nodeType: nodeType,
          expanded: expanded,
          onClick: this.handleClick
        }),
        _react2.default.createElement(
          'label',
          _extends({}, styling.apply(undefined, [['label', 'nestedNodeLabel']].concat(stylingArgs)), {
            onClick: expandable ? this.handleClick : undefined
          }),
          labelRenderer.apply(undefined, stylingArgs)
        ),
        _react2.default.createElement(
          'span',
          _extends({}, styling.apply(undefined, ['nestedNodeItemString'].concat(stylingArgs)), {
            onClick: expandable ? this.handleClick : undefined
          }),
          renderedItemString
        ),
        _react2.default.createElement(
          'ul',
          styling.apply(undefined, ['nestedNodeChildren'].concat(stylingArgs)),
          renderedChildren
        )
      );
    }
  }]);

  return JSONNestedNode;
}(_react2.default.Component);

JSONNestedNode.propTypes = {
  getItemString: _propTypes2.default.func.isRequired,
  nodeTypeIndicator: _propTypes2.default.any,
  nodeType: _propTypes2.default.string.isRequired,
  data: _propTypes2.default.any,
  hideRoot: _propTypes2.default.bool.isRequired,
  createItemString: _propTypes2.default.func.isRequired,
  styling: _propTypes2.default.func.isRequired,
  collectionLimit: _propTypes2.default.number,
  keyPath: _propTypes2.default.arrayOf(_propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number])).isRequired,
  labelRenderer: _propTypes2.default.func.isRequired,
  shouldExpandNode: _propTypes2.default.func,
  level: _propTypes2.default.number.isRequired,
  sortObjectKeys: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.bool]),
  isCircular: _propTypes2.default.bool,
  expandable: _propTypes2.default.bool
};
JSONNestedNode.defaultProps = {
  data: [],
  circularCache: [],
  level: 0,
  expandable: true
};
exports.default = JSONNestedNode;